Subject: Re: [PATCH] AF_PACKET: Fix PACKET_MMAP on 64-bit kernel/32-bit user systems

From: Patrick McHardy <[email-masked]>
Date: Mon, 10 Aug 2009 19:17:06 +0200

[email-masked] wrote:
> PACKET_MMAP sets up a ring buffer at a memory location so that kernel
> and user space can read from it without extra overhead. However, the
> data is written with a header, struct tpacket_hdr, which begins with an
> unsigned long field, tp_status. This means in a split 64-bit/32-bit
> environment the kernel- and user-space reads from the mmap'd region will
> be different, since in kernel-space the field is 64-bit while in
> user-space the field is 32-bit.
> 
> The following patch makes the size of the structure constant by changing
> the tp_status field to 32-bits. It does not appear to need 64-bits,
> since only 4-bits are actually used throughout the AF_PACKET code.
> 
> Signed-off-by: Chase Douglas <[email-masked]>
> --- a/include/linux/if_packet.h   2009-08-10 16:53:11.000000000 +0000
> +++ b/include/linux/if_packet.h   2009-08-10 16:53:28.000000000 +0000
> @@ -65,7 +65,7 @@ struct tpacket_auxdata
> 
>  struct tpacket_hdr
>  {
> -       unsigned long   tp_status;
> +       unsigned int    tp_status;

This changes the layout on 64 bit and thus breaks compatibility.
The tpacket2_hdr doesn't suffer from this problem.